#include <stdio.h>
#include <malloc.h>
#include <assert.h>

#define MAX(a, b) ((a)>(b)?(a):(b))

int main(void)
{
  int Z;

  scanf(" %d", &Z);

  for(int iii = 0; iii < Z; iii++)
    {
      int R, S;
      int **pole;

      scanf(" %d %d", &R, &S);

      pole = (int **)malloc(R * sizeof(int *));
      for(int i = 0; i < R; i++) pole[i] = (int *)malloc(S * sizeof(int));

      char s[1005];

      for(int i = 0; i < R; i++)
	{
	  scanf("%s", s);
	  for(int j = 0; j < S; j++)
	    {
	      if(s[j] == '.') pole[i][j] = 1;
	      else            pole[i][j] = 0;
	    }

	}

      for(int i = 1; i < S; i++)
	{
	  for(int j = 0; j < R; j++)
	    {
	      if(i - j < 0) break;

	      if(pole[j][i-j] == 0) continue;

	      pole[j][i-j] = 0;

	      if(j > 0) pole[j][i-j] += pole[j-1][i-j];
	      if(i - j > 0) pole[j][i-j] += pole[j][i-j-1];
	    }
	}

      for(int i = 1; i < R; i++)
	{
	  for(int j = 0; j < R; j++)
	    {
	      if((S - j <= 0) || (i + j >= R)) break;
	      if(pole[i+j][S-j-1] == 0) continue;

	      pole[i+j][S-j-1] = 0;

	      if(S - j > 1) pole[i+j][S-j-1] += pole[i+j][S-j-2];
	      pole[i+j][S-j-1] += pole[i+j-1][S-j-1];
	    }
	}
/*
       for(int i = 0; i < R; i++)
       {
         for(int j = 0; j < S; j++)
	 { 
           putchar('0' + pole[i][j]);
	 }
	 printf("\n");
       }	   
*/
      printf("Existuje %d ruznych cest.\n", pole[R-1][S-1]);  

      for(int i = 0; i < R; i++) free(pole[i]);
      free(pole);
    }

  return 0;
}
