#include <stdio.h>
#include <assert.h>

#define ABS(x) ((x)>0?(x):-(x))

int hledej(int r, int s, int dr, int ds, char *slovo, char pole[][200], int R, int S)
{
  int len = strlen(slovo);
  int max = len;
  
  if(ABS(dr) + ABS(ds) == 1)
  {
    if(ABS(dr) == 1)
    {
      if(len > R)
      {
        for(int i = R; i < len; i++)
	{
	  if(slovo[i] != slovo[i % R]) return 0;
	}
	max = R;
      }
    }
    else
    {
      if(len > S)
      {
        for(int i = S; i < len; i++)
        {
          if(slovo[i] != slovo[i % S]) return 0;
        }
        max = S;
      }
    }
  }
        
	 

  int r0, s0;

  r0 = r;
  s0 = s;

  if((pole[r][s] & 127) != slovo[0]) return 0;

  for(int i = 1; i < max; i++)
    {
      r += dr;
      s += ds;

      if(r == R) r = 0;
      if(r < 0) r = R - 1;
      if(s == S) s = 0;
      if(s < 0) s = S - 1;

      if((pole[r][s] & 127) != slovo[i]) return 0;
    }

  r = r0;
  s = s0;

  for(int i = 0; i < max; i++)
    {

      if(r == R) r = 0;
      if(r < 0) r = R - 1;
      if(s == S) s = 0;
      if(s < 0) s = S - 1;

      pole[r][s] |= 128;
      r += dr;
      s += ds;

    }

  return 1;
}
      


int main(void)
{
  int Z;

  scanf(" %d", &Z);

  for(int iii = 0; iii < Z; iii++)
    {
      char pole[200][200];
      int R, S;

      scanf(" %d %d", &R, &S);

      for(int i = 0; i < R; i++)
	{
	  scanf("%s", &(pole[i][0]));
	  //printf("%s", pole[i]);
	}

      int K;

      scanf(" %d", &K);

      char slovo[200];

      for(int k = 0; k < K; k++)
	{
	  scanf("%s", slovo);
	  
	  for(int i = 0; i < R; i++)
	    {
	      for(int j = 0; j < S; j++)
		{
		  hledej(i, j, 1, 0, slovo, pole , R, S);
		  //hledej(i, j, 0, 1, slovo, pole , R, S);
		  //hledej(i, j, -1, 0, slovo, pole , R, S);
		  //hledej(i, j, 0, -1, slovo, pole , R, S);
		  //hledej(i, j, 1, 1, slovo, pole , R, S);
		  //hledej(i, j, 1, -1, slovo, pole , R, S);
		  hledej(i, j, -1, 1, slovo, pole , R, S);
		  //hledej(i, j, -1, -1, slovo, pole , R, S);
		}
	    }
	}

      for(int i = 0; i < R; i++)
	{
	  for(int j = 0; j < S; j++)
	    {
	      if(!(pole[i][j] & 128)) putchar(pole[i][j] & 127);
	    }
	}
	printf("\n");
    }

  return 0;
}
