#include <stdio.h>
#include <malloc.h>
#include <assert.h>

int main(void)
{
  int Z;

  scanf(" %d", &Z);

  for(int iii = 0; iii < Z; iii++)
    {
      int R, S;
      int **pole;
      int R0, S0;

      printf("Skladacka cislo %d:\n",iii + 1);

      scanf(" %d %d", &R, &S);

      pole = (int **)malloc(R * sizeof(int *));
      for(int i = 0; i < R; i++)
	pole[i] = (int *)malloc(S * sizeof(int));

      for(int i = 0; i < R; i++)
	{
	  for(int j = 0; j < S; j++)
	    {
	      scanf(" %d", &(pole[i][j]));
	      if(pole[i][j] == 0)
		{
		  R0 = i;
		  S0 = j;
		}
	    }
	}

      for(;;)
	{
	  int T;

	  scanf(" %d", &T);

	  if(T == 0) break;

	  int ok = 0; 

	  if((R0 < R - 1) && (pole[R0+1][S0] == T)) ok = 1;
	  else if((R0 > 0) && (pole[R0-1][S0] == T)) ok = 2;
	  else if((S0 < S - 1) && (pole[R0][S0+1] == T)) ok = 3;
	  else if((S0 > 0) && (pole[R0][S0-1] == T)) ok = 4;

	  switch(ok)
	    {
	    case 0: printf("Neplatny tah kamenem %d.\n", T);
	      break;

	    case 1: printf("Kamen %d presunut nahoru.\n", T);
	      pole[R0][S0] = T;
	      pole[R0+1][S0] = 0;
	      R0++;
	      break;

	    case 2: printf("Kamen %d presunut dolu.\n", T);
	      pole[R0][S0] = T;
	      pole[R0-1][S0] = 0;
	      R0--;
	      break;

	    case 3: printf("Kamen %d presunut doleva.\n", T);
	      pole[R0][S0] = T;
	      pole[R0][S0+1] = 0;
	      S0++;
	      break;

	    case 4: printf("Kamen %d presunut doprava.\n", T);
	      pole[R0][S0] = T;
	      pole[R0][S0-1] = 0;
	      S0--;
	      break;
	    }

	} 

      for(int i = 0; i < R; i++)
	{
	  for(int j = 0; j < S; j++)
	    {
	      if(j == 0) printf("%d", pole[i][j]);
	      else       printf(" %d", pole[i][j]);
	    }
	  printf("\n");
	}
      printf("\n");

      for(int i = 0; i < R; i++) free(pole[i]);
      free(pole);
    }

  return 0;
}
